/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================
*/

#include "../include/common.h"
#include "../include/findrep.h"

/* Find And Replace - OBJECT - TEXT TO FIND - TEXT TO REPLACE OR NULL - OPTIONS */
void OzEDIT_FindAndReplace(struct _OzEDIT_Object *object,gchar *t_find,gchar *t_replace,gboolean c_case,gboolean c_findall,gboolean c_replace) {
#warning "OzEDIT_FindAndReplace - BUGGED !"
    GtkTextIter i_start,i_end;
    gchar *buffer,*index,token[80];
    gulong sizeofbuffer;
    guint offset,ti,n_found=0,n_replaced=0;
    if((object == NULL)&&(t_find == NULL)) return;
    /* Crea ITERs */
    gtk_text_buffer_get_start_iter(object->text_buffer,&i_start);
    gtk_text_buffer_get_end_iter(object->text_buffer,&i_end);
    /* Alloca la memoria necessaria */
    sizeofbuffer = gtk_text_buffer_get_char_count(object->text_buffer);
    buffer = g_malloc0(sizeofbuffer);
    /* Prelev il buffer */
    buffer = gtk_text_buffer_get_text(object->text_buffer,&i_start,&i_end,FALSE);
    ti = 0;
    for(offset = 0;offset < sizeofbuffer;offset++) {
    	if((g_unichar_isalnum(buffer[offset]))||(g_unichar_ispunct(buffer[offset]))) {  /* Alfanumerico o Simbolo */
	    token[ti] = buffer[offset];
	    ti++;
	    token[ti] = '\0';
	} else { /* Altrimenti analizza il TOKEN */
	    if(((c_case == TRUE) && (g_strstr_len(token,strlen(token),t_find) != NULL))||((c_case == FALSE) && (g_strstr_len(g_ascii_strdown(token,strlen(token)),strlen(token),g_ascii_strdown(t_find,strlen(t_find))) != NULL))) { /* Cazzarola ha trovato qualcosa ! */ 
		n_found++;	    
    		gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_start,offset-strlen(token));
		gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_end,offset);
		gtk_text_buffer_apply_tag(object->text_buffer,object->tag_graybg,&i_start,&i_end);
		gtk_text_buffer_place_cursor(object->text_buffer,&i_start);
		
		if(c_replace) {
		    if((!c_findall)&&(OzEDIT_AreYouSureDialog("Replace this occurrence ?") == GTK_RESPONSE_YES)) {
			gtk_text_buffer_delete(object->text_buffer,&i_start,&i_end);
			gtk_text_buffer_insert(object->text_buffer,&i_start,t_replace,strlen(t_replace));
			n_replaced++;
		    }
		}
		if((!c_findall)&&(OzEDIT_AreYouSureDialog("Continue ?") == GTK_RESPONSE_NO)) break;
	    }
	    ti=0;
	}
    }
    if(c_replace) { 
	OzEDIT_InfoDialog("Found %d occourrence of %s and replaced %d with %s \0",n_found,t_find,n_replaced,t_replace); 
    } else {
	OzEDIT_InfoDialog("Found %d occourrence of %s \0",n_found,t_find);     
    }
}

